#include "Player.h"
#include "Area.h"
#include "Globals.h"
#include "Menu.h"
#include "Game.h"
#include <Bild.h>


Player::Player()
    : Entity( PlayerEntityType::INSTANCE, 1 )
{
    setModelDaten( window->zBildschirm()->zGraphicsApi()->getModel( "player" ) );
    Bild* b = new Bild();
    b->neuBild( 10, 10, 0xFFFFFFFF );
    Textur* tex = currentGame->zScreen()->zGraphicsApi()->createOrGetTextur( "player", 0 );
    if( !tex->zBild() )
        tex->setBildZ( b );
    else
        b->release();
    Model3DTextur* textur = new Model3DTextur();
    textur->setPolygonTextur( 0, dynamic_cast<Textur*>(tex->getThis()) );
    textur->setPolygonTextur( 1, dynamic_cast<Textur*>(tex->getThis()) );
    textur->setPolygonTextur( 2, dynamic_cast<Textur*>(tex->getThis()) );
    textur->setPolygonTextur( 3, dynamic_cast<Textur*>(tex->getThis()) );
    textur->setPolygonTextur( 4, dynamic_cast<Textur*>(tex->getThis()) );
    textur->setPolygonTextur( 5, tex );
    setModelTextur( textur );
    for( int i = 0; i < 9; i++ )
    {
        ItemSlot* slot = new ItemSlot( 50, 0, i, 0, ANY_DIRECTION, 0 );
        addSlot( slot );
    }
    currentGame->setVisibility( this, 1 );
}

Player::~Player()
{}

bool Player::tick( double time )
{
    if( currentGame->getCurrentPlayerId() == id )
    {
        currentGame->zKamera()->setPosition( pos + Vec3<float>( 0.f, 0.f, 1.5f ) );
        //currentGame->zKamera()->setDirection( faceDir );
        /*
        char b = 0;
        serverMessageReader->lese( &b, 1 );
        if( hasTarget && dimensions->hat( 0 ) )
        {
            if( entityTarget == -1 )
            {
                Block* block = zBlockAt( target, dimensions->z( 0 )->getDimensionId() );
                if( block )
                    block->setAmbientFactor( block->getAmbientFactor() - 0.2f );
            }
        }
        if( b == 1 )
        {
            serverMessageReader->lese( (char*)&entityTarget, 4 );
            hasTarget = 1;
        }
        else if( b == 2 )
        {
            serverMessageReader->lese( (char*)&target.x, 4 );
            serverMessageReader->lese( (char*)&target.y, 4 );
            serverMessageReader->lese( (char*)&target.z, 4 );
            int side = 0;
            serverMessageReader->lese( (char*)&side, 4 );
            hasTarget = 1;
        }
        else
            hasTarget = 0;
        if( hasTarget && dimensions->hat( 0 ) )
        {
            if( entityTarget == -1 )
            {
                Block* block = zBlockAt( target, dimensions->z( 0 )->getDimensionId() );
                if( block )
                    block->setAmbientFactor( block->getAmbientFactor() + 0.2f );
            }
        }*/
        ((Game*)(Menu*)menuRegister->get( "game" ))->updatePosition( pos, false, { 0, 0, 0 } );
    }
    return Entity::tick( time );
}


PlayerEntityType::PlayerEntityType()
    : EntityType( ID )
{}

void PlayerEntityType::loadSuperEntity( Entity* zEntity, Framework::StreamReader* zReader ) const
{
    EntityType::loadSuperEntity( zEntity, zReader );
}

Entity* PlayerEntityType::createEntity() const
{
    return new Player();
}
